"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const uuid_by_string_1 = __importDefault(require("uuid-by-string"));
const crypto_1 = __importDefault(require("crypto"));
const utilities_1 = require("../../utilities");
const classifierMap_json_1 = __importDefault(require("../classifierMap.json"));
class Adaptor {
    constructor(options, adaptorName) {
        this.options = options;
        this.log = options.logger;
        this.classifierFields = classifierMap_json_1.default[adaptorName];
    }
    // ===== Common helper functions to be used in generating report(s) ===== //
    getUuid(reportIdentifier) {
        return uuid_by_string_1.default(reportIdentifier);
    }
    getFingerprint(defectIdentifier) {
        const hash = crypto_1.default.createHash('sha256');
        hash.update(defectIdentifier);
        return hash.digest('hex');
    }
    getClassifiers(type) {
        return utilities_1.getDefectClassifiers(type, this.classifierFields);
    }
}
exports.Adaptor = Adaptor;
//# sourceMappingURL=Adaptor.js.map