
exports.up = function(knex) {
    return knex.schema.table('correlation', function(t) {
       t.dropColumn('token_A');
       t.dropColumn('token_B'); 
       t.dropColumn('files');
       t.dropColumn('callstack'); 
       t.string('crashProject');
       t.string('defectProject');
       t.index(['universe', 'crashProject', 'defectProject', 'fingerprint'], 'correlationIndex');
     });
};

exports.down = function(knex) {
   return knex.schema.table('correlation', function(t) {
        t.dropColumn('crashProject');
        t.dropColumn('defectProject');
        t.string('token_A');
        t.string('token_B'); 
        t.string('files');
        t.string('callstack'); 
        t.dropIndex(['universe', 'crashProject', 'defectProject', 'fingerprint'], 'correlationIndex');
   });
};
