"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable-next-line: no-var-requires
var packageJson = require('./../../package.json');
var crypto_1 = require("crypto");
var node_machine_id_1 = require("node-machine-id");
var os = __importStar(require("os"));
var moduleResolver_1 = require("../helpers/moduleResolver");
var processHelper_1 = require("../helpers/processHelper");
var backtraceStackTrace_1 = require("./backtraceStackTrace");
/**
 * BacktraceReport describe current exception/message payload message to Backtrace
 */
var BacktraceReport = /** @class */ (function () {
    /**
     * Create new BacktraceReport - report information that will collect information
     * for Backtrace.
     *
     * Possible existing scenarios:
     * arg1: error + arg2: attributes = all required
     * arg1: object, arg2: nothing
     *
     * @param err Error or message - content to report
     * @param attributes Report attributes dictionary
     * @param attachments Report attachments that Backtrace will send to API
     */
    function BacktraceReport(data, clientAttributes, attachments) {
        if (data === void 0) { data = ''; }
        if (clientAttributes === void 0) { clientAttributes = {}; }
        if (attachments === void 0) { attachments = []; }
        this.data = data;
        this.clientAttributes = clientAttributes;
        this.attachments = attachments;
        // reprot id
        this.uuid = this.generateUuid();
        // timestamp
        this.timestamp = Math.floor(new Date().getTime() / 1000);
        // lang
        this.lang = 'nodejs';
        // environment version
        this.langVersion = process.version;
        // Backtrace-ndoe name
        this.agent = packageJson.name;
        // Backtrace-node  version
        this.agentVersion = packageJson.version;
        // main thread name
        this.mainThread = 'main';
        this.classifiers = [];
        /**
         * Current report attributes
         */
        this.attributes = {};
        /**
         * Backtrace complex objet
         */
        this.annotations = {};
        this.tabWidth = 8;
        this.contextLineCount = 200;
        if (!clientAttributes) {
            clientAttributes = {};
        }
        this.splitAttributesFromAnnotations(clientAttributes);
        if (!attachments) {
            attachments = [];
        }
        this.setError(data);
    }
    /**
     * Check if report contains exception information
     */
    BacktraceReport.prototype.isExceptionTypeReport = function () {
        return this.detectReportType(this.data);
    };
    BacktraceReport.prototype.getPayload = function () {
        return this.data;
    };
    /**
     * Set error or message in BacktraceReport object
     * @param err Current error
     */
    BacktraceReport.prototype.setError = function (err) {
        this.data = err;
        if (this.detectReportType(err)) {
            this.err = err;
            this.classifiers = [err.name];
        }
        else {
            this.err = new Error(err);
            this.classifiers = [];
        }
    };
    /**
     * @deprecated
     * Please don't use log method in new BacktraceReport object.
     */
    BacktraceReport.prototype.log = function () {
        console.warn('log method is deprecated.');
    };
    /**
     * @deprecated
     * Please don't use trace method in new BacktraceReport object
     */
    BacktraceReport.prototype.trace = function () {
        console.warn('trace method is deprecated.');
    };
    /**
     * Add new attributes to existing report attributes
     * @param attributes new report attributes object
     */
    BacktraceReport.prototype.addObjectAttributes = function (attributes) {
        this.clientAttributes = __assign(__assign(__assign({}, this.clientAttributes), this.attributes), attributes);
    };
    BacktraceReport.prototype.addAttribute = function (key, value) {
        this.clientAttributes[key] = value;
    };
    BacktraceReport.prototype.addAnnotation = function (key, value) {
        this.annotations[key] = value;
    };
    BacktraceReport.prototype.getAttachments = function () {
        return this.attachments;
    };
    BacktraceReport.prototype.toJson = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // why library should wait to retrieve source code data?
                    // architecture decision require to pass additional parameters
                    // not in constructor, but in additional method.
                    return [4 /*yield*/, this.collectReportInformation()];
                    case 1:
                        // why library should wait to retrieve source code data?
                        // architecture decision require to pass additional parameters
                        // not in constructor, but in additional method.
                        _a.sent();
                        result = {
                            uuid: this.uuid,
                            timestamp: this.timestamp,
                            lang: this.lang,
                            langVersion: this.langVersion,
                            mainThread: this.mainThread,
                            classifiers: this.classifiers,
                            threads: { main: this.stackTrace.toJson() },
                            agent: this.agent,
                            agentVersion: this.agentVersion,
                            annotations: this.annotations,
                            attributes: this.attributes,
                            sourceCode: this.stackTrace.getSourceCode(),
                        };
                        if (this.attributes['symbolication_id']) {
                            result.symbolication = 'sourcemap';
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    BacktraceReport.prototype.setSourceCodeOptions = function (tabWidth, contextLineCount) {
        this.tabWidth = tabWidth;
        this.contextLineCount = contextLineCount;
    };
    BacktraceReport.prototype.collectReportInformation = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // get stack trace to retrieve calling module information
                        this.stackTrace = new backtraceStackTrace_1.BacktraceStackTrace(this.err);
                        this.stackTrace.setSourceCodeOptions(this.tabWidth, this.contextLineCount);
                        return [4 /*yield*/, this.stackTrace.parseStackFrames()];
                    case 1:
                        _b.sent();
                        // retrieve calling module object
                        _a = moduleResolver_1.readModule(this.stackTrace.getCallingModulePath()), this._callingModule = _a[0], this._callingModulePath = _a[1];
                        // combine attributes
                        this.attributes = __assign(__assign({}, this.readBuiltInAttributes()), this.clientAttributes);
                        // combine annotations
                        this.annotations = this.readAnnotation();
                        return [2 /*return*/];
                }
            });
        });
    };
    BacktraceReport.prototype.readBuiltInAttributes = function () {
        return __assign(__assign(__assign(__assign({}, processHelper_1.readMemoryInformation()), processHelper_1.readProcessStatus()), this.readAttributes()), this.readErrorAttributes());
    };
    BacktraceReport.prototype.detectReportType = function (err) {
        return err instanceof Error;
    };
    BacktraceReport.prototype.generateUuid = function () {
        var bytes = crypto_1.pseudoRandomBytes(16);
        return (bytes.slice(0, 4).toString('hex') +
            '-' +
            bytes.slice(4, 6).toString('hex') +
            '-' +
            bytes.slice(6, 8).toString('hex') +
            '-' +
            bytes.slice(8, 10).toString('hex') +
            '-' +
            bytes.slice(10, 16).toString('hex'));
    };
    BacktraceReport.prototype.readErrorAttributes = function () {
        if (!this.detectReportType(this.err)) {
            return {
                'error.message': this.err,
            };
        }
        this.classifiers = [this.err.name];
        return {
            'error.message': this.err.message,
        };
    };
    BacktraceReport.prototype.readAttributes = function () {
        var mem = process.memoryUsage();
        var _a = (this._callingModule || {}), name = _a.name, version = _a.version, main = _a.main, description = _a.description, author = _a.author;
        var result = {
            'process.age': Math.floor(process.uptime()),
            'uname.uptime': os.uptime(),
            'uname.machine': process.arch,
            'uname.version': os.release(),
            'uname.sysname': process.platform,
            'vm.rss.size': mem.rss,
            'gc.heap.total': mem.heapTotal,
            'gc.heap.used': mem.heapUsed,
            'node.env': process.env.NODE_ENV,
            'debug.port': process.debugPort,
            application: name,
            version: version,
            main: main,
            description: description,
            author: author,
            guid: node_machine_id_1.machineIdSync(true),
            hostname: os.hostname(),
        };
        var cpus = os.cpus();
        if (cpus && cpus.length > 0) {
            result['cpu.count'] = cpus.length;
            result['cpu.brand'] = cpus[0].model;
        }
        return result;
    };
    BacktraceReport.prototype.readAnnotation = function () {
        var result = {
            'Environment Variables': process.env,
            'Exec Arguments': process.execArgv,
            Dependencies: moduleResolver_1.readModuleDependencies(this._callingModulePath),
        };
        if (this.detectReportType(this.err)) {
            result['Exception'] = this.err;
        }
        return __assign(__assign({}, result), this.annotations);
    };
    BacktraceReport.prototype.splitAttributesFromAnnotations = function (clientAttributes) {
        for (var key in clientAttributes) {
            if (clientAttributes.hasOwnProperty(key)) {
                var element = this.clientAttributes[key];
                if (!element) {
                    continue;
                }
                if (typeof element === 'object') {
                    this.annotations[key] = element;
                }
                else {
                    this.attributes[key] = element;
                }
            }
        }
    };
    return BacktraceReport;
}());
exports.BacktraceReport = BacktraceReport;
//# sourceMappingURL=backtraceReport.js.map